#!/bin/sh

PATH=/bin:/sbin:/usr/bin:/usr/sbin
SYSTEM=/tmp/system

echo Starting $0 `date`

mkdir -p ${SYSTEM}

mount /dev/mmcblk2p10 ${SYSTEM}

if [ -d ${UPDATE_MP}/updates/system ]
then
   echo "Updating /system"
   cp -rfp ${UPDATE_MP}/updates/system/* ${SYSTEM}

   echo "Changing system files modes"
   cd ${UPDATE_MP}/updates/system
   find bin -type f -exec chmod go-w,a+x ${SYSTEM}/{} \;
   find bin -type f -exec chown 0.2000 ${SYSTEM}/{} \;
   find xbin -type f -exec chmod a+x ${SYSTEM}/{} \;
   if [ -d lib ]
   then
      find lib -type f -exec chmod go-w,a-x ${SYSTEM}/{} \;
   else
      echo "Cleaning up kernel modules"
      rm -rf ${SYSTEM}/lib/modules
   fi
   cd -
fi

umount ${SYSTEM}

if [ -f ${UPDATE_MP}/tmp/nboote.bin ]
then
   echo "Flashing Normal Boot Environment"
   dd if=${UPDATE_MP}/tmp/nboote.bin of=/dev/mmcblk2 seek=30720 count=256 bs=512
fi

if [ -f ${UPDATE_MP}/tmp/ramdisk.uimg ]
then
   echo "Flashing Ramdisk"
   dd if=${UPDATE_MP}/tmp/ramdisk.uimg of=/dev/mmcblk2 seek=10240 count=600 bs=512
fi

/usr/bin/chgboot recovery
/usr/bin/chgboot normal

echo Done $0 `date`
